#include "types.h"
#include "LPC21xx.h"
#include "config.h"
#include "ps2kbd.h"
#include "extint.h"
#include "armVIC.h"
//#include "delay.h"

#define kbDAT (IO0PIN & (KB_DAT))
#define kbCLK (IO0PIN & (KB_CLK))
#define K_STARTBIT    1			
#define K_PARITYBIT  10			
#define K_STOPBIT    11			

//extern unsigned char edge;
extern unsigned char bitcount;
//extern uint8_t kb2host;


void extISR1(void)
{
  static unsigned char data;                // Holds the received scan code
  uint8_t clkstat;
  uint8_t datstat;
  uint8_t paritystat;

  ISR_ENTRY();

  clkstat = kbCLK;//check CLK pin state;
  datstat = kbDAT;//check DAT pin state;

  bitcount++;
  
  if (bitcount==K_STARTBIT)
    {
      if (datstat || clkstat)	bitcount=0;
      data=0;
      paritystat=0;

    }
  else if (bitcount==K_PARITYBIT)
    {
      paritystat = datstat;
    }
  else if (bitcount==K_STOPBIT)
    {
      decode (data);
      bitcount=0;
    }
  else
    {
      // For all bits from 2, 3...9 (total 8-bit)
      data= data >> 1;
      if (datstat)
        data = data | 0x80;
    }
//    }

  EXTINT = EINT1; //clear interrupt
  VICVectAddr = 0;
  ISR_EXIT();

}//extISR

